//
// Simple Shoot
// Copyright (C) 2010-2011 Xavier MICHEL (xavier.michel.mx440@gmail.com)
//
// This software is provided as-is, without any express or implied warranty.
// In no event will the authors be held liable for any damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it freely,
// subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented;
//    you must not claim that you wrote the original software.
//    If you use this software in a product, an acknowledgment
//    in the product documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such,
//    and must not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source distribution.
//

#ifndef EPHEMERE_HPP
#define EPHEMERE_HPP

#include "constantes.hpp"

#include "ObjetMonde.hpp"

class ObjectData;

/*!
*	\class Ephemere
*	\brief Un élément graphique éphémère, une explosion par exemple
*/


class Ephemere : public ObjetMonde {

public:

        /*!
            \param monde Le monde dans lequel évolue l'éphémère
            \param position La position initiale du pion
            \param taille La taille du pion
            \param anim L'animation de l'éphémère
            \param objectData Les données attachées à cet objet
        */
        Ephemere(
                Monde *monde,
                const sf::Vector2f &position,
                const sf::Vector2f &taille,
                ImgAnim *anim,
                ObjectData *objectData
                );

        /*!
            \brief Mise à jour de l'éphémère, en particulier est-il en fin de vie et à détruire ?
        */
        void update();

};

#endif // EPHEMERE_HPP
